#*************************************************************************
#
#   Copyright 2000 Novell, Inc.  All Rights Reserved.
#
#   With respect to this file, Novell hereby grants to Developer a 
#   royalty-free, non-exclusive license to include this sample code 
#   and derivative binaries in its product. Novell grants to Developer 
#   worldwide distribution rights to market, distribute or sell this 
#   sample code file and derivative binaries as a component of 
#   Developer's product(s).  Novell shall have no obligations to 
#   Developer or Developer's customers with respect to this code.
#
#   DISCLAIMER:
#
#   Novell disclaims and excludes any and all express, implied, and 
#   statutory warranties, including, without limitation, warranties 
#   of good title, warranties against infringement, and the implied 
#   warranties of merchantability and fitness for a particular purpose.  
#   Novell does not warrant that the software will satisfy customer's 
#   requirements or that the licensed works are without defect or error 
#   or that the operation of the software will be uninterrupted.  
#   Novell makes no warranties respecting any technical services or 
#   support tools provided under the agreement, and disclaims all other 
#   warranties, including the implied warranties of merchantability and 
#   fitness for a particular purpose.
#
#***************************************************************************/
#============================================================================
#	Name:           CSkeletonDriver.mak
#	%version:        4 %
#	%created_by:     pblanchard %
#	%date_modified:  Thu Feb 07 09:21:13 2008 %
#
#============================================================================
#
#	This make source file is intended to be used by "Makefile". 
#	Makefile sets up the following environment variables:
#
#		prog	= <program root name> (eg., dhost)
#		build	= debug | release
#
#----------------------------------------------------------------------------

include $(BASE_PATH)/platform.mak

.PHONY : all fault

.SUFFIXES :
.SUFFIXES : .c .cpp .h .hpp .d .obj .rc

# -- set programmables to environment or default values -- 
ifndef prog
fault : 
	$(ECHO) Program name not specified, are you using Makefile?
endif

ifndef build
fault : 
	$(ECHO) Build directory not specified, are you using Makefile?
endif


# -- include common compiler and linker flags and definitions
include $(BASE_PATH)/win/settings.mak

# -- include platform-independent source
include ../modules.mak
	
# -- platform-specific source files --
plat_src = dllmain.cpp

# -- all source files
src = $(plat_src) $(cskl_src)

# -- construct object file names from source file names
obj =  $(patsubst %.c,$(pbld)/$(build)/%.obj,$(patsubst %.cpp,$(pbld)/$(build)/%.obj,$(src)))

# -- utility variables -- 
em :=
sp := $(em) $(em)

# -- setup include and library paths
inc = .;../;$(BASE_PATH)/Interface

# -- compiler definitions -- 
ccdefs = $(common_ccdefs) "/DCSKELETONDRIVER_API=__declspec(dllexport)"
ccincs = /I"$(subst ;,"$(sp)/I",$(inc))"
ccflags = $(common_ccflags)

# -- linker definitions -- 
lflags = $(common_lflags_dll)

libs = advapi32.lib user32.lib kernel32.lib
libs += $(BASE_PATH)/win/dirxmllib/$(pbld)/$(build)/dirxmllib.lib

# -- tool names -- 
link = link.exe
cc = cl.exe
mt = mt.exe

VPATH = ..

# -- pattern rules --
$(pbld)/$(build)/%.obj : %.cpp
	$(cc) /c $(ccflags) $(ccdefs) $(ccincs) $<

# -- primary and secondary targets -- 
all : $(pbld)/$(build)/$(prog).dll

.DELETE_ON_ERROR: $(pbld)/$(build)/$(prog).dll

$(pbld)/$(build)/$(prog).dll : $(obj)
	$(link) $(lflags) $(libs) $+ /out:$@ /map:$(@:.dll=.map)
	$(mt) -manifest $(pbld)/$(build)/$(prog).dll.manifest -outputresource:$(pbld)/$(build)/$(prog).dll;2

#-------------------------------------------------------------------------------
# -- include file that does ideps dependencies
#-------------------------------------------------------------------------------
include	$(BASE_PATH)/depends.mak

